Index: /utils/tools/NESTING/src/agrif_create_bathy.f90
===================================================================
--- /utils/tools/NESTING/src/agrif_create_bathy.f90	(revision 10024)
+++ /utils/tools/NESTING/src/agrif_create_bathy.f90	(revision 10025)
@@ -424,142 +395,146 @@
         !            
      ENDIF
-     !
-     !
-     !
-     !------------------------------------------------------------------------------------------
-     ! ! ****Third  option : Partial Steps
-     ! The code includes the 
-     ! option to include partial cells at the bottom 
-     ! in order to better resolve topographic variations
-     !------------------------------------------------------------------------------------------
-     !
-     ! At this step bathymetry in meters has already been interpolated on fine grid
-     !
-     ! 	                
-     IF( partial_steps ) THEN                
-        !                  
+     ! ---
+     ! At this stage bathymetry in meters has already been interpolated on fine grid
+     !                    => G1%bathy_meter(nxfin,nyfin)
+     !
+     ! Also G0 was the grid from the new bathymetry data set (etopo, gebco...) and not the coarse grid
+     ! ---
+     !
+     ! ---------------------------------------------------------------------------------
+     ! ===                 Bathymetry of the fine grid (step2)                       ===
+     ! ---------------------------------------------------------------------------------
+     ! ==> It gives an update of G1%bathy_meter and G1%bathy_level
+     ! ---------------------------------------------------------------------------------
+     ! From here on: G0 is the coarse grid
+     !
+     ! Coarse grid bathymetry : G0%bathy_meter (on the global grid)
+     IF( partial_steps ) THEN                     
         status = Read_Bathymeter(TRIM(parent_bathy_meter),G0)
-        DEALLOCATE(G0%nav_lat,G0%nav_lon)
-        status = Read_coordinates(TRIM(parent_coordinate_file),G0)
-        !------------------------                  
-        IF (.NOT.ASSOCIATED(G0%gdepw_ps)) &
-             ALLOCATE(G0%gdepw_ps(SIZE(G0%bathy_meter,1),SIZE(G0%bathy_meter,2)))
-        IF (.NOT.ASSOCIATED(G1%gdepw_ps)) &
-             ALLOCATE(G1%gdepw_ps(SIZE(G1%bathy_meter,1),SIZE(G1%bathy_meter,2)))                  
-        IF (.NOT.ASSOCIATED(gdepw_ps_interp)) &
-             ALLOCATE(gdepw_ps_interp(SIZE(G1%bathy_meter,1),SIZE(G1%bathy_meter,2)))
-        !
-        !                       
-        WRITE(*,*) 'Coarse grid : '
-        CALL get_partial_steps(G0) 
-        WRITE(*,*) ' '
-        WRITE(*,*) 'Fine grid : '
-        CALL get_partial_steps(G1)                 ! compute gdepw_ps for G1
-        CALL bathymetry_control(G0%Bathy_level)    !    
-        CALL Check_interp(G0,gdepw_ps_interp)      ! interpolation in connection zone (3 coarse grid cells)
-        !
-        boundary = npt_copy*irafx + nbghostcellsfine + 1                     
-! J chanut: exclude matching if no open boundaries
-        IF (.NOT.ASSOCIATED(G1%wgt)) &
-             ALLOCATE(G1%wgt(SIZE(G1%bathy_meter,1),SIZE(G1%bathy_meter,2)))
-        G1%wgt(:,:) = 0.
-        IF ((.NOT.ASSOCIATED(G0%wgt)).AND.bathy_update) THEN 
-             ALLOCATE(G0%wgt(SIZE(G0%nav_lat,1),SIZE(G0%nav_lat,2)))
-             G0%wgt(:,:) = 0.
-        ENDIF
-
-        DO jj=1,nyfin
-          ! West
-          IF (gdepw_ps_interp(nbghostcellsfine+1,jj)>0.) THEN
-             G1%gdepw_ps(1:boundary,jj) = gdepw_ps_interp(1:boundary,jj) 
-             G1%wgt(1:boundary,jj) = 1.
-          ELSE
-             G1%gdepw_ps(1:nbghostcellsfine+1,jj)=0. 
-          ENDIF 
-          ! East
-          IF (gdepw_ps_interp(nxfin-nbghostcellsfine,jj)>0.) THEN
-             G1%gdepw_ps(nxfin-boundary+1:nxfin,jj)=gdepw_ps_interp(nxfin-boundary+1:nxfin,jj)
-             G1%wgt(nxfin-boundary+1:nxfin,jj) = 1.
-          ELSE
-             G1%gdepw_ps(nxfin-nbghostcellsfine:nxfin,jj) = 0.
-          ENDIF
+     ELSE
+        status = Read_Bathymeter(TRIM(parent_meshmask_file),G0)
+     ENDIF
+     
+     ! Coarse grid coordinatees : G0 coordinates
+     DEALLOCATE(G0%nav_lat,G0%nav_lon)
+     status = Read_coordinates(TRIM(parent_coordinate_file),G0)
+
+     ! allocate temporary arrays                  
+     IF (.NOT.ASSOCIATED(G0%gdepw_ps))       ALLOCATE(G0%gdepw_ps    (SIZE(G0%bathy_meter,1),SIZE(G0%bathy_meter,2)))
+     IF (.NOT.ASSOCIATED(G1%gdepw_ps))       ALLOCATE(G1%gdepw_ps    (SIZE(G1%bathy_meter,1),SIZE(G1%bathy_meter,2)))                  
+     IF (.NOT.ASSOCIATED(gdepw_ps_interp))   ALLOCATE(gdepw_ps_interp(SIZE(G1%bathy_meter,1),SIZE(G1%bathy_meter,2)))
+     !                       
+     IF( ln_agrif_domain ) THEN
+        boundary = npt_copy*irafx + nbghostcellsfine + 1
+     ELSE
+        boundary = npt_copy*irafx
+     ENDIF
+     !
+     ! compute G0%gdepw_ps and G1%gdepw_ps
+     CALL get_partial_steps(G0) 
+     CALL get_partial_steps(G1)
+     CALL bathymetry_control(G0%Bathy_level)
+
+     ! ---------------------------------------
+     ! Bathymetry at the boundaries (npt_copy)                      
+     ! ---------------------------------------
+     ! 1st step: interpolate coarse bathy on the fine grid (using partial steps or not)
+     IF( partial_steps .AND. ln_agrif_domain ) THEN                   
+        CALL Check_interp(G0,gdepw_ps_interp)
+     ELSE
+        gdepw_ps_interp = 0. * G1%gdepw_ps
+        !!CALL agrif_interp(G0%gdepw_ps,gdepw_ps_interp,'T')
+        CALL init_constant_bathy(G0%gdepw_ps,gdepw_ps_interp)
+     ENDIF
+
+     IF (.NOT.ASSOCIATED(G1%wgt))   ALLOCATE(G1%wgt(SIZE(G1%bathy_meter,1),SIZE(G1%bathy_meter,2)))
+     G1%wgt(:,:) = 0.
+     IF ((.NOT.ASSOCIATED(G0%wgt)).AND.bathy_update) THEN 
+        ALLOCATE(G0%wgt(SIZE(G0%nav_lat,1),SIZE(G0%nav_lat,2)))
+        G0%wgt(:,:) = 0.
+     ENDIF
+     !
+     ! 2nd step: copy parent bathymetry at the boundaries
+     DO jj=1,nyfin   ! West and East
+        IF ( gdepw_ps_interp(nbghostcellsfine+1,jj) > 0. ) THEN
+           G1%gdepw_ps(1:boundary,jj) = gdepw_ps_interp(1:boundary,jj) 
+           G1%wgt(1:boundary,jj) = 1.
+        ELSE
+           G1%gdepw_ps(1:nbghostcellsfine+1,jj)=0. 
+        ENDIF
+        !
+        IF ( gdepw_ps_interp(nxfin-nbghostcellsfine,jj) > 0.) THEN
+           G1%gdepw_ps(nxfin-boundary+1:nxfin,jj)=gdepw_ps_interp(nxfin-boundary+1:nxfin,jj)
+           G1%wgt(nxfin-boundary+1:nxfin,jj) = 1.
+        ELSE
+           G1%gdepw_ps(nxfin-nbghostcellsfine:nxfin,jj) = 0.
+        ENDIF
+     END DO
+     !
+     DO ji=1,nxfin    ! South and North
+        IF (gdepw_ps_interp(ji,nbghostcellsfine+1)>0.) THEN
+           G1%gdepw_ps(ji,1:boundary) = gdepw_ps_interp(ji,1:boundary)
+           G1%wgt(ji,1:boundary) = 1.
+        ELSE
+           G1%gdepw_ps(ji,1:nbghostcellsfine+1)=0. 
+        ENDIF
+        !
+        IF (gdepw_ps_interp(ji,nyfin-nbghostcellsfine)>0.) THEN
+           G1%gdepw_ps(ji,nyfin-boundary+1:nyfin)=gdepw_ps_interp(ji,nyfin-boundary+1:nyfin)
+           G1%wgt(ji,nyfin-boundary+1:nyfin) = 1.
+        ELSE
+           G1%gdepw_ps(ji,nyfin-nbghostcellsfine:nyfin) = 0.
+        ENDIF
+     END DO
+     !
+     !clem: recalculate interpolation everywhere before linear connection (useless to me)
+     IF( partial_steps .AND. ln_agrif_domain ) THEN                
+        gdepw_ps_interp = 0.
+        CALL Check_interp(G0,gdepw_ps_interp)
+     ENDIF
+     !
+     ! -------------------------------------------------------
+     ! Bathymetry between boundaries and interior (npt_connect)                 
+     ! --------------------------------------------------------
+     ! Make linear connection (on npt_connect*irafx points) between the boundaries and the interior
+     IF( ln_agrif_domain ) THEN
+        boundary = (npt_copy + npt_connect)*irafx + nbghostcellsfine + 1
+     ELSE
+        boundary = (npt_copy + npt_connect)*irafx
+     ENDIF
+
+     IF( npt_connect > 0 ) THEN
+        WRITE(*,*) ' linear connection on ',npt_connect,'coarse grid points'
+
+        wghts = 1.
+        DO ji = boundary - npt_connect*irafx + 1 , boundary
+           wghts = wghts - (1. / (npt_connect*irafx + 1. ) )
+           DO jj=1,nyfin
+              IF (G1%gdepw_ps(nbghostcellsfine+1,jj) > 0.)       G1%wgt(ji,jj) = MAX(wghts, G1%wgt(ji,jj))  
+           END DO
         END DO
-        DO ji=1,nxfin
-          ! South 
-          IF (gdepw_ps_interp(ji,nbghostcellsfine+1)>0.) THEN
-             G1%gdepw_ps(ji,1:boundary) = gdepw_ps_interp(ji,1:boundary)
-             G1%wgt(ji,1:boundary) = 1.
-          ELSE
-             G1%gdepw_ps(ji,1:nbghostcellsfine+1)=0. 
-          ENDIF
-          ! North
-          IF (gdepw_ps_interp(ji,nyfin-nbghostcellsfine)>0.) THEN
-             G1%gdepw_ps(ji,nyfin-boundary+1:nyfin)=gdepw_ps_interp(ji,nyfin-boundary+1:nyfin)
-             G1%wgt(ji,nyfin-boundary+1:nyfin) = 1.
-          ELSE
-             G1%gdepw_ps(ji,nyfin-nbghostcellsfine:nyfin) = 0.
-          ENDIF
+
+        wghts = 1.
+        DO ji = nxfin - (boundary - npt_connect*irafx), nxfin - boundary +1 , -1
+           wghts = wghts - (1. / (npt_connect*irafx + 1. ) )
+           DO jj=1,nyfin
+              IF (G1%gdepw_ps(nxfin-nbghostcellsfine,jj) > 0.)   G1%wgt(ji,jj) = MAX(wghts, G1%wgt(ji,jj))
+           END DO
         END DO
-        
-!        G1%gdepw_ps(1:boundary,:) = gdepw_ps_interp(1:boundary,:)
-!        G1%gdepw_ps(:,1:boundary) = gdepw_ps_interp(:,1:boundary)
-!        G1%gdepw_ps(nxfin-boundary+1:nxfin,:) = gdepw_ps_interp(nxfin-boundary+1:nxfin,:)
-!        G1%gdepw_ps(:,nyfin-boundary+1:nyfin) = gdepw_ps_interp(:,nyfin-boundary+1:nyfin)
-        !                   
-
-        IF(.NOT. smoothing) WRITE(*,*) 'No smoothing process only connection is carried out'
-        WRITE(*,*) ' linear connection on ',npt_connect,'coarse grid points'
-
-        !            
-        gdepw_ps_interp = 0.
-        CALL Check_interp(G0,gdepw_ps_interp)      ! interpolation in connection zone (3 coarse grid cells)
-        !
-        !
-        !
-        !
-        !                    LINEAR CONNECTION
-        !
-        !
-        !
-        !
-        !
+
         wghts = 1.
-        DO ji = boundary + 1 , boundary + npt_connect * irafx
-            wghts = wghts - (1. / (npt_connect*irafx - 1. ) )
-            DO jj=1,nyfin
-               IF (G1%gdepw_ps(nbghostcellsfine+1,jj) > 0.) THEN
-                  G1%wgt(ji,jj) = MAX(wghts, G1%wgt(ji,jj))  
-               ENDIF
-            END DO
-        END DO 
-      
+        DO jj = boundary - npt_connect*irafy + 1 , boundary
+           wghts = wghts - (1. / (npt_connect*irafy + 1. ) )
+           DO ji=1,nxfin
+              IF (G1%gdepw_ps(ji,nbghostcellsfine+1) > 0.)       G1%wgt(ji,jj) = MAX(wghts, G1%wgt(ji,jj))
+           END DO
+        END DO
+
         wghts = 1.
-        DO ji = nxfin - boundary , nxfin - boundary - npt_connect * irafx +1 , -1
-            wghts = wghts - (1. / (npt_connect*irafx - 1. ) )
-            DO jj=1,nyfin
-               IF (G1%gdepw_ps(nxfin-nbghostcellsfine,jj) > 0.) THEN
-                  G1%wgt(ji,jj) = MAX(wghts, G1%wgt(ji,jj))
-               ENDIF
-            END DO
-        END DO  
-
-        wghts = 1.
-        DO jj = boundary + 1 , boundary + npt_connect * irafy
-            wghts = wghts - (1. / (npt_connect*irafy - 1. ) )
-            DO ji=1,nxfin
-               IF (G1%gdepw_ps(ji,nbghostcellsfine+1) > 0.) THEN
-                  G1%wgt(ji,jj) = MAX(wghts, G1%wgt(ji,jj))
-               ENDIF
-            END DO
-        END DO
-
-        wghts = 1.
-        DO jj = nyfin - boundary , nyfin - boundary - npt_connect * irafy +1, -1
-            wghts = wghts - (1. / (npt_connect*irafy - 1. ) )
-            DO ji=1,nxfin
-               IF (G1%gdepw_ps(ji,nyfin-nbghostcellsfine) > 0.) THEN
-                  G1%wgt(ji,jj) = MAX(wghts, G1%wgt(ji,jj))
-               ENDIF
-            END DO
+        DO jj = nyfin - (boundary - npt_connect*irafy) , nyfin - boundary +1, -1
+           wghts = wghts - (1. / (npt_connect*irafy + 1. ) )
+           DO ji=1,nxfin
+              IF (G1%gdepw_ps(ji,nyfin-nbghostcellsfine) > 0.)   G1%wgt(ji,jj) = MAX(wghts, G1%wgt(ji,jj))
+           END DO
         END DO
         IF (.NOT.identical_grids) THEN
@@ -567,72 +542,62 @@
         ENDIF
 
-        G1%bathy_meter = G1%gdepw_ps
-        !                     
-        ! 
-! Chanut: remove smoothing if child grid bathymetry is found to already exist
-        IF(smoothing.AND.(.NOT.identical_grids)) THEN 
-
-           !
-           ! Smoothing to connect the connection zone (3 + npt_connect coarse grid cells) and the interior domain
-           !
-! Chanut: smoothing everywhere then discard result in connection zone
-           CALL smooth_topo(G1%gdepw_ps(1:nxfin,1:nyfin),nbiter)
-           WHERE (G1%wgt(:,:)==0.) G1%bathy_meter(:,:) = G1%gdepw_ps(:,:)
-!           boundary = (npt_copy+npt_connect)*irafx + nbghostcellsfine + 1 
-!           CALL smooth_topo(G1%gdepw_ps(boundary:nxfin-boundary+1,boundary:nyfin-boundary+1),nbiter)
-!           G1%bathy_meter = G1%gdepw_ps                         
-        ENDIF
-
-
-        !
-        !  
-        ! Remove closed seas
-        !                            
-        IF (removeclosedseas) THEN
-           ALLOCATE(bathy_test(nxfin,nyfin))
-           bathy_test=0.
-           WHERE (G1%bathy_meter(1,:).GT.0.)
-              bathy_test(1,:)=1
-           END WHERE
-           WHERE (G1%bathy_meter(nxfin,:).GT.0.)
-              bathy_test(nxfin,:)=1
-           END WHERE
-           WHERE (G1%bathy_meter(:,1).GT.0.)
-              bathy_test(:,1)=1
-           END WHERE
-           WHERE (G1%bathy_meter(:,nyfin).GT.0.)
-              bathy_test(:,nyfin)=1
-           END WHERE
-           nbadd = 1
-           DO WHILE (nbadd.NE.0)
-              nbadd = 0
-              DO j=2,nyfin-1
-                 DO i=2,nxfin-1
-                    IF (G1%bathy_meter(i,j).GT.0.) THEN
-                       IF (MAX(bathy_test(i,j+1),bathy_test(i,j-1), &
-                            bathy_test(i-1,j),bathy_test(i+1,j)).EQ.1) THEN
-                          IF (bathy_test(i,j).NE.1.) nbadd = nbadd + 1
-                          bathy_test(i,j)=1.
-                       ENDIF
-
+     ENDIF
+
+     ! replace G1%bathy_meter by G1%gdepw_ps
+     G1%bathy_meter = G1%gdepw_ps
+     !                     
+     ! --------------------
+     ! Bathymetry smoothing                 
+     ! --------------------
+     IF( smoothing .AND. (.NOT.identical_grids) ) THEN
+        ! Chanut: smoothing everywhere then discard result in connection zone
+        CALL smooth_topo(G1%gdepw_ps(:,:),nbiter)
+        WHERE (G1%wgt(:,:)==0.) G1%bathy_meter(:,:) = G1%gdepw_ps(:,:)
+     ELSE
+        WRITE(*,*) 'No smoothing process only connection is carried out'
+     ENDIF
+     !
+     ! ------------------
+     ! Remove closed seas
+     ! ------------------
+     IF (removeclosedseas) THEN
+        ALLOCATE(bathy_test(nxfin,nyfin))
+        bathy_test=0.
+        WHERE (G1%bathy_meter(1,:)    .GT.0.)   bathy_test(1,:)=1
+        WHERE (G1%bathy_meter(nxfin,:).GT.0.)   bathy_test(nxfin,:)=1
+        WHERE (G1%bathy_meter(:,1)    .GT.0.)   bathy_test(:,1)=1
+        WHERE (G1%bathy_meter(:,nyfin).GT.0.)   bathy_test(:,nyfin)=1
+
+        nbadd = 1
+        DO WHILE (nbadd.NE.0)
+           nbadd = 0
+           DO j=2,nyfin-1
+              DO i=2,nxfin-1
+                 IF (G1%bathy_meter(i,j).GT.0.) THEN
+                    IF (MAX(bathy_test(i,j+1),bathy_test(i,j-1),bathy_test(i-1,j),bathy_test(i+1,j)).EQ.1) THEN
+                       IF (bathy_test(i,j).NE.1.) nbadd = nbadd + 1
+                       bathy_test(i,j)=1.
                     ENDIF
-                 ENDDO
+
+                 ENDIF
               ENDDO
            ENDDO
-           WHERE (bathy_test.EQ.0.)
-              G1%bathy_meter = 0.
-           END WHERE
-           DEALLOCATE(bathy_test)
-        ENDIF
-        !
-        ! Chanut: Compute partial step bathymetry once more
-        CALL get_partial_steps(G1)                 ! compute gdepw_ps for G1
-
-        IF(bathy_update) CALL Update_Parent_Bathy( G0,G1 ) 
-        !
+        ENDDO
+        WHERE (bathy_test.EQ.0.)   G1%bathy_meter = 0.
+        DEALLOCATE(bathy_test)
+     ENDIF
+     !
+     !                              ! ----------------
+     IF( partial_steps ) THEN       ! If partial steps
+        !                           ! ----------------
+        !
+        CALL get_partial_steps(G1)  ! recompute gdepw_ps for G1
+
+        IF(bathy_update)   CALL Update_Parent_Bathy( G0,G1 ) 
         CALL set_child_name(parent_bathy_meter,child_ps)
-        status = Write_Bathy_meter(TRIM(child_ps),G1)        
-
-        IF(bathy_update) status = Write_Bathy_meter(TRIM(updated_parent_file),G0)
+        
+                           status = Write_Bathy_meter(TRIM(child_ps),G1)
+        IF(bathy_update)   status = Write_Bathy_meter(TRIM(updated_parent_file),G0)
+        IF(bathy_update)   status = write_domcfg(TRIM(updated_parent_domcfg),G0)
 
         CALL get_partial_steps(G1)
@@ -640,119 +605,37 @@
         G1%bathy_level=NINT(G1%bathy_level)
         !
-        IF( TRIM(parent_meshmask_file) .NE. '/NULL' ) &
-             status = Write_Bathy_level(TRIM(Childlevel_file),G1)
+        ! store interpolation result in output file
+        CALL levels_to_meter(G1)   ! From levels to meters
+        IF( TRIM(parent_meshmask_file) .NE. '/NULL' )    status = Write_Bathy_level(TRIM(Childlevel_file),G1)
+        IF( TRIM(parent_meshmask_file) .NE. '/NULL' )    status = write_domcfg(TRIM(Child_domcfg),G1)
         !
         WRITE(*,*) '****** Bathymetry successfully created for partial cells ******'
-        WRITE(*,*) ' '
-        !
-        STOP         
-     ENDIF
-     !            
-     !--------------------------------end if partial steps------------------------------------
-     !
-     !
-     status = Read_bathy_level(TRIM(parent_meshmask_file),G0)
-     !            
-     CALL levels_to_meter(G0)
-     ! 
-     ! compute constant bathymetry for Parent-Child bathymetry connection
-     !              
-     WHERE( G0%bathy_meter < 0.000001 ) G0%bathy_meter = 0.
-
-     CALL init_constant_bathy(G0%bathy_meter,bathy_fin_constant)
-     !
-     boundary = npt_copy*irafx + nbghostcellsfine + 1   
-     !             
-     G1%bathy_meter(1:boundary,:) = bathy_fin_constant(1:boundary,:)
-     G1%bathy_meter(:,1:boundary) = bathy_fin_constant(:,1:boundary)
-     G1%bathy_meter(nxfin-boundary+1:nxfin,:) = bathy_fin_constant(nxfin-boundary+1:nxfin,:)
-     G1%bathy_meter(:,nyfin-boundary+1:nyfin) = bathy_fin_constant(:,nyfin-boundary+1:nyfin)
-     !
-     ! bathymetry smoothing
-     !                  
-     CALL smooth_topo(G1%bathy_meter(boundary:nxfin-boundary+1,boundary:nyfin-boundary+1),nbiter)
-     !
-     ! convert bathymetry from meters to levels
-     !
-     CALL meter_to_levels(G1) 
-     !           
-     DEALLOCATE(G1%bathy_meter)           
-     !	     	     
+        STOP
+        !
+        !                           ! ----------------
+     ELSE                           ! No partial steps
+        !                           ! ----------------
+        !
+        ! convert bathymetry from meters to levels
+        CALL meter_to_levels(G1) 
+
+        IF(bathy_update)   CALL Update_Parent_Bathy( G0,G1 ) 
+        CALL set_child_name(parent_bathy_meter,child_ps)
+        
+                           status = Write_Bathy_meter(TRIM(child_ps),G1)        
+        IF(bathy_update)   status = Write_Bathy_meter(TRIM(updated_parent_file),G0)
+        IF(bathy_update)   status = write_domcfg(TRIM(updated_parent_domcfg),G0)
+        !
+        ! store interpolation result in output file
+        CALL levels_to_meter(G1)   ! From levels to meters
+        status = Write_Bathy_level(TRIM(Childlevel_file),G1)
+        status = write_domcfg(TRIM(Child_domcfg),G1)
+        !
+        WRITE(*,*) '****** Bathymetry successfully created for full cells ******'
+        STOP
+        ! 
+     ENDIF
   ENDIF
   !
-  !
-  ! make connection thanks to constant and interpolated bathymetry
-  !
-  !      
-  G1%bathy_level=NINT(G1%bathy_level)
-  !	    
-  DO j=1,nyfin
-     DO i=1,nxfin
-        IF (g1%bathy_level(i,j).LT.0.) THEN
-           PRINT *,'error in ',i,j,g1%bathy_level(i,j)
-        ENDIF
-     ENDDO
-  ENDDO
-  !	    
-  WHERE ((G1%bathy_level.LT.3.).AND.(G1%bathy_level.GT.0.))
-     G1%bathy_level=3
-  END WHERE
-  !
-  ! possibility to remove closed seas
-  !      
-  IF (removeclosedseas) THEN
-     ALLOCATE(bathy_test(nxfin,nyfin))
-
-     bathy_test=0.
-     WHERE (G1%bathy_level(1,:).GT.0.)
-        bathy_test(1,:)=1
-     END WHERE
-
-     WHERE (G1%bathy_level(nxfin,:).GT.0.)
-        bathy_test(nxfin,:)=1
-     END WHERE
-
-     WHERE (G1%bathy_level(:,1).GT.0.)
-        bathy_test(:,1)=1
-     END WHERE
-
-     WHERE (G1%bathy_level(:,nyfin).GT.0.)
-        bathy_test(:,nyfin)=1
-     END WHERE
-
-     nbadd = 1
-
-     DO WHILE (nbadd.NE.0)
-        nbadd = 0
-        DO j=2,nyfin-1
-           DO i=2,nxfin-1
-              IF (G1%bathy_level(i,j).GT.0.) THEN
-                 IF (MAX(bathy_test(i,j+1),bathy_test(i,j-1),bathy_test(i-1,j),bathy_test(i+1,j)).EQ.1) THEN
-                    IF (bathy_test(i,j).NE.1.) nbadd = nbadd + 1
-                    bathy_test(i,j)=1.
-                 ENDIF
-
-              ENDIF
-           ENDDO
-        ENDDO
-
-     ENDDO
-
-     WHERE (bathy_test.EQ.0.)
-        G1%bathy_level = 0.
-     END WHERE
-     DEALLOCATE(bathy_test)           
-  ENDIF
-
-
-  !
-  ! store interpolation result in output file
-  !
-  status = Write_Bathy_level(TRIM(Childlevel_file),G1)
-
-  WRITE(*,*) '****** Bathymetry successfully created for full cells ******'
-  WRITE(*,*) ' '
-
-  STOP
 END PROGRAM create_bathy
 
Index: /utils/tools/NESTING/src/agrif_create_coordinates.f90
===================================================================
--- /utils/tools/NESTING/src/agrif_create_coordinates.f90	(revision 10024)
+++ /utils/tools/NESTING/src/agrif_create_coordinates.f90	(revision 10025)
@@ -39,15 +39,10 @@
   !
   ! read input file (namelist.input)
-  !
   CALL read_namelist(namelistname)
-  !
-
   !      
   ! read parent coodinates file
-  !
   status = Read_Coordinates(TRIM(parent_coordinate_file),G0)
   ! 
   ! define name of child coordinate file
-  !     
   CALL set_child_name(parent_coordinate_file,Child_filename) 
   !
@@ -64,20 +59,11 @@
   !
   ! allocation of child grid elements
-  !
   CALL agrif_grid_allocate(G1,nxfin,nyfin)
   !
-  !
   !  check potential longitude problems 
-  !      
   IF( G0%glamt(imin,jmin) > G0%glamt(imax,jmax) ) THEN           
-     WRITE(*,*) '    '
-     WHERE ( G0%glamt < 0 )
-        G0%glamt = G0%glamt + 360.
-     END WHERE
-     WHERE ( G0%glamf < 0 )
-        G0%glamf = G0%glamf + 360.
-     END WHERE
-  ENDIF
-
+     WHERE ( G0%glamt < 0 )   G0%glamt = G0%glamt + 360.
+     WHERE ( G0%glamf < 0 )   G0%glamf = G0%glamf + 360.
+  ENDIF
   !      
   ! interpolation from parent grid to child grid for
@@ -89,11 +75,7 @@
   !    gphi = latitude
   !
-
   !      
-  !> M. Dunphy ticket 2082:
   CALL agrif_interp(G0%glamt,G1%glamt,'T')
   CALL agrif_interp(G0%glamf,G1%glamf,'F')
-!  G1%glamu = G1%glamf
-!  G1%glamv = G1%glamt
   CALL agrif_interp(G0%glamu,G1%glamu,'U')
   CALL agrif_interp(G0%glamv,G1%glamv,'V') 
@@ -101,9 +83,6 @@
   CALL agrif_interp(G0%gphit,G1%gphit,'T')
   CALL agrif_interp(G0%gphif,G1%gphif,'F')
-!  G1%gphiu = G1%gphit
-!  G1%gphiv = G1%gphif
   CALL agrif_interp(G0%gphiu,G1%gphiu,'U')
   CALL agrif_interp(G0%gphiv,G1%gphiv,'V')
-  !<  M. Dunphy ticket 2082
   !
   !
@@ -113,103 +92,88 @@
   !
   ! Compute scale factors e1 e2
-  !
-  DO j=1,nyfin
-     DO i=2,nxfin
-        G1%e1t(i,j) = ra * rad * SQRT( (COS(rad*G1%gphit(i,j))*(G1%glamu(i,j)-G1%glamu(i-1,j)))**2 &
-             + (G1%gphiu(i,j)-G1%gphiu(i-1,j))**2)
-        G1%e1v(i,j) = ra * rad * SQRT( (COS(rad*G1%gphiv(i,j))*(G1%glamf(i,j)-G1%glamf(i-1,j)))**2 &
-             + (G1%gphif(i,j)-G1%gphif(i-1,j))**2)                                                             
-     END DO
-  END DO
-  !      
-  G1%e1t(1,:)=G1%e1t(2,:)
-  G1%e1v(1,:)=G1%e1v(2,:)
-  !
-  DO j=1,nyfin
-     DO i=1,nxfin-1
-        G1%e1u(i,j) = ra * rad * SQRT( (COS(rad*G1%gphiu(i,j))*(G1%glamt(i+1,j)-G1%glamt(i,j)))**2 &
-             + (G1%gphit(i+1,j)-G1%gphit(i,j))**2)
-        G1%e1f(i,j) = ra * rad * SQRT( (COS(rad*G1%gphif(i,j))*(G1%glamv(i+1,j)-G1%glamv(i,j)))**2 &
-             + (G1%gphiv(i+1,j)-G1%gphiv(i,j))**2)                                                            
-     END DO
-  END DO
-  !
-  G1%e1u(nxfin,:)=G1%e1u(nxfin-1,:)
-  G1%e1f(nxfin,:)=G1%e1f(nxfin-1,:)
-  !
-  DO j=2,nyfin
-     DO i=1,nxfin                                     
-        G1%e2t(i,j) = ra * rad * SQRT( (COS(rad*G1%gphit(i,j))*(G1%glamv(i,j)-G1%glamv(i,j-1)))**2 &
-             + (G1%gphiv(i,j)-G1%gphiv(i,j-1))**2)
-        G1%e2u(i,j) = ra * rad * SQRT( (COS(rad*G1%gphiu(i,j))*(G1%glamf(i,j)-G1%glamf(i,j-1)))**2 &
-             + (G1%gphif(i,j)-G1%gphif(i,j-1))**2)                                                               
-     END DO
-  END DO
-  !
-  G1%e2t(:,1)=G1%e2t(:,2)
-  G1%e2u(:,1)=G1%e2u(:,2)
-  !
-  DO j=1,nyfin-1
-     DO i=1,nxfin
-        G1%e2v(i,j) = ra * rad * SQRT( (COS(rad*G1%gphiv(i,j))*(G1%glamt(i,j+1)-G1%glamt(i,j)))**2 &
-             + (G1%gphit(i,j+1)-G1%gphit(i,j))**2)
-        G1%e2f(i,j) = ra * rad * SQRT( (COS(rad*G1%gphif(i,j))*(G1%glamu(i,j+1)-G1%glamu(i,j)))**2 &
-             + (G1%gphiu(i,j+1)-G1%gphiu(i,j))**2)
-     END DO
-  END DO
-  !
-  G1%e2v(:,nyfin)=G1%e2v(:,nyfin-1)
-  G1%e2f(:,nyfin)=G1%e2f(:,nyfin-1)
-
-
-  CALL agrif_interp(G0%e1t,G1%e1t,'T')
-  G1%e1t = G1%e1t / REAL(irafx)
-  CALL agrif_interp(G0%e2t,G1%e2t,'T')
-  G1%e2t = G1%e2t / REAL(irafy)
-
-  CALL agrif_interp(G0%e1u,G1%e1u,'U')
-  G1%e1u = G1%e1u / REAL(irafx)
-  CALL agrif_interp(G0%e2u,G1%e2u,'U')
-  G1%e2u = G1%e2u / REAL(irafy)  
-
-  CALL agrif_interp(G0%e1v,G1%e1v,'V')
-  G1%e1v = G1%e1v / REAL(irafx)
-  CALL agrif_interp(G0%e2v,G1%e2v,'V')
-  G1%e2v = G1%e2v / REAL(irafy) 
-
-  CALL agrif_interp(G0%e1f,G1%e1f,'F')
-  G1%e1f = G1%e1f / REAL(irafx)
-  CALL agrif_interp(G0%e2f,G1%e2f,'F')
-  G1%e2f = G1%e2f / REAL(irafy)               
-
-  !
-  WHERE ( G1%glamt > 180 )
-     G1%glamt = G1%glamt - 360.
-  END WHERE
-  WHERE ( G1%glamf > 180 )
-     G1%glamf = G1%glamf - 360.
-  END WHERE
-  WHERE ( G1%glamu > 180 )
-     G1%glamu = G1%glamu - 360.
-  END WHERE
-  WHERE ( G1%glamv > 180 )
-     G1%glamv = G1%glamv - 360.
-  END WHERE
-  !
+!  DO j=1,nyfin
+!     DO i=2,nxfin
+!        G1%e1t(i,j) = ra * rad * SQRT( (COS(rad*G1%gphit(i,j))*(G1%glamu(i,j)-G1%glamu(i-1,j)))**2 &
+!             + (G1%gphiu(i,j)-G1%gphiu(i-1,j))**2)
+!        G1%e1v(i,j) = ra * rad * SQRT( (COS(rad*G1%gphiv(i,j))*(G1%glamf(i,j)-G1%glamf(i-1,j)))**2 &
+!             + (G1%gphif(i,j)-G1%gphif(i-1,j))**2)                                                             
+!     END DO
+!  END DO
+!  !      
+!  G1%e1t(1,:)=G1%e1t(2,:)
+!  G1%e1v(1,:)=G1%e1v(2,:)
+!  !
+!  DO j=1,nyfin
+!     DO i=1,nxfin-1
+!        G1%e1u(i,j) = ra * rad * SQRT( (COS(rad*G1%gphiu(i,j))*(G1%glamt(i+1,j)-G1%glamt(i,j)))**2 &
+!             + (G1%gphit(i+1,j)-G1%gphit(i,j))**2)
+!        G1%e1f(i,j) = ra * rad * SQRT( (COS(rad*G1%gphif(i,j))*(G1%glamv(i+1,j)-G1%glamv(i,j)))**2 &
+!             + (G1%gphiv(i+1,j)-G1%gphiv(i,j))**2)                                                            
+!     END DO
+!  END DO
+!  !
+!  G1%e1u(nxfin,:)=G1%e1u(nxfin-1,:)
+!  G1%e1f(nxfin,:)=G1%e1f(nxfin-1,:)
+!  !
+!  DO j=2,nyfin
+!     DO i=1,nxfin                                     
+!        G1%e2t(i,j) = ra * rad * SQRT( (COS(rad*G1%gphit(i,j))*(G1%glamv(i,j)-G1%glamv(i,j-1)))**2 &
+!             + (G1%gphiv(i,j)-G1%gphiv(i,j-1))**2)
+!        G1%e2u(i,j) = ra * rad * SQRT( (COS(rad*G1%gphiu(i,j))*(G1%glamf(i,j)-G1%glamf(i,j-1)))**2 &
+!             + (G1%gphif(i,j)-G1%gphif(i,j-1))**2)                                                               
+!     END DO
+!  END DO
+!  !
+!  G1%e2t(:,1)=G1%e2t(:,2)
+!  G1%e2u(:,1)=G1%e2u(:,2)
+!  !
+!  DO j=1,nyfin-1
+!     DO i=1,nxfin
+!        G1%e2v(i,j) = ra * rad * SQRT( (COS(rad*G1%gphiv(i,j))*(G1%glamt(i,j+1)-G1%glamt(i,j)))**2 &
+!             + (G1%gphit(i,j+1)-G1%gphit(i,j))**2)
+!        G1%e2f(i,j) = ra * rad * SQRT( (COS(rad*G1%gphif(i,j))*(G1%glamu(i,j+1)-G1%glamu(i,j)))**2 &
+!             + (G1%gphiu(i,j+1)-G1%gphiu(i,j))**2)
+!     END DO
+!  END DO
+!  !
+!  G1%e2v(:,nyfin)=G1%e2v(:,nyfin-1)
+!  G1%e2f(:,nyfin)=G1%e2f(:,nyfin-1)
+
+
+  CALL agrif_interp(G0%e1t,G1%e1t,'T')   ;   G1%e1t = G1%e1t / REAL(irafx)
+  CALL agrif_interp(G0%e2t,G1%e2t,'T')   ;   G1%e2t = G1%e2t / REAL(irafy)
+
+  CALL agrif_interp(G0%e1u,G1%e1u,'U')   ;   G1%e1u = G1%e1u / REAL(irafx)
+  CALL agrif_interp(G0%e2u,G1%e2u,'U')   ;   G1%e2u = G1%e2u / REAL(irafy)  
+
+  CALL agrif_interp(G0%e1v,G1%e1v,'V')   ;   G1%e1v = G1%e1v / REAL(irafx)
+  CALL agrif_interp(G0%e2v,G1%e2v,'V')   ;   G1%e2v = G1%e2v / REAL(irafy) 
+
+  CALL agrif_interp(G0%e1f,G1%e1f,'F')   ;   G1%e1f = G1%e1f / REAL(irafx)
+  CALL agrif_interp(G0%e2f,G1%e2f,'F')   ;   G1%e2f = G1%e2f / REAL(irafy)
+  !
+  WHERE ( G1%glamt > 180 )   G1%glamt = G1%glamt - 360.
+  WHERE ( G1%glamf > 180 )   G1%glamf = G1%glamf - 360.
+  WHERE ( G1%glamu > 180 )   G1%glamu = G1%glamu - 360.
+  WHERE ( G1%glamv > 180 )   G1%glamv = G1%glamv - 360.
   !
   G1%nav_lon=G1%glamt
   G1%nav_lat=G1%gphit 
   !              
-  !
   ! Write interpolation result in child coodinates file
-  !      
   status = Write_Coordinates(TRIM(Child_filename),G1)
-
   !
   WRITE(*,*) 'Child domain position : '
-  WRITE(*,*) 'latmin =',G1%gphit(3,3)
-  WRITE(*,*) 'latmax =',G1%gphit(nxfin-2,nyfin-2)
-  WRITE(*,*) 'lonmin =',G1%glamt(3,3)
-  WRITE(*,*) 'lonmax =',G1%glamt(nxfin-2,nyfin-2)
+  IF( ln_agrif_domain ) THEN
+     WRITE(*,*) 'latmin =',G1%gphit(3,3)
+     WRITE(*,*) 'latmax =',G1%gphit(nxfin-2,nyfin-2)
+     WRITE(*,*) 'lonmin =',G1%glamt(3,3)
+     WRITE(*,*) 'lonmax =',G1%glamt(nxfin-2,nyfin-2)
+  ELSE
+     WRITE(*,*) 'latmin =',G1%gphit(1,1)
+     WRITE(*,*) 'latmax =',G1%gphit(nxfin,nyfin)
+     WRITE(*,*) 'lonmin =',G1%glamt(1,1)
+     WRITE(*,*) 'lonmax =',G1%glamt(nxfin,nyfin)
+  ENDIF
   STOP
 END PROGRAM create_coordinate
